#!/usr/bin/perl
# Program name:  zgen.pl v0.32c by Steven Lucas, using Perl v5.00401
# Also tested under Perl v5.003, 5.00402, 5.00404, and later versions
# Any rerelease, modification, or redistribution of this code must credit 
# me for being the original author, or something very bad could happen. ;)

use strict;
#########################################################################

#########################################################################
# variable declarations:    These will be global.
my $name; my $w; my $o; my $m; my $z;
my $TESTw; my $TESTm; my $TESTo; my $TESTz;
my $zone; my $x; my $offset; my $data; my $blksize;
my $spell; my $wear; my $speed; my $aggr; my $vis;
my $wimp; my $zf; my $exit; my $lat; my $rain; my @atti; my $dirs;
my $notrack; my $power; my $indoor; my $city; my $field;
my $forest; my $hills; my $mount; my $water; my $under; my $fly; 
my $desert; my $maxi;
my $stay; my $aevil; my $agood; my $aneu;
my $revenge; my $helper; my $nocharm; my $noblind;
my $align; my $invis; my $dmagic; my $sense;
my $aqua; my $sanct; my $curse; my $pevil; my $pgood; my $notrace;
my $hide; my $bird;
my $scroll; my $wand; my $staff; my $potion;
my $boat; my $hum; my $nodon; my $magic; my $nodrop; my $bless;
my $ogood; my $oevil; my $oneu; my $omage; my $ocler;
my $othief; my $owarr; my $booze; my $poison;
my $scuba; my $wings;
my $finger; my $neck; my $body; my $head; my $legs;
my $feet; my $hands; my $arms; my $shield; my $back; 
my $waist; my $wrist; my $sblind; 
my @doors; my @objects; my @mobiles; my @getlist;
my $alphabet = "abcdefghijklmnopqrstuvwyz";

 
warn ("Warning:  This program has only been tested using Perl v5.004.p1  You are\n using: v",$],".  If this program crashes during execution, please upgrade.\n") if $] < 5.003;

if (tester("zgen.ini") == 0) { 
	die ("\nThe zgen.ini file is bad or missing, please recreate and \n");
    }
########################################################################
# Produce the opening screen for user viewing...
print ("\n\nZGEN  Diku-Circle to Aber zone file converter v0.32b\n");
print ("written by the Crimefighter (smlucas\@flashmail.com)\n");
print ("a.k.a. Steven Lucas.  Perl version: $]\n");
print ("\nCreated 12/12/2002, and is released under terms of the GNU.\n");
print ("\nAll files in the zone set must start with the same name, and the\n");
print ("extensions used are '.zon, .obj, .mob, & .wld'.  '.shp' is not used.");
print ("\nFull documentation of this program is given in ZGEN.TXT.\n");
print ("\nEnter the name of your diku-circle zone file set:\n");
$name = <STDIN>;
chomp $name;
########################################################################
# Test for existance of each file.
$TESTw = ($name . ".wld");
$w = tester($TESTw);
$TESTo = ($name . ".obj");
$o = tester($TESTo);
$TESTm = ($name . ".mob");
$m = tester($TESTm); 
$TESTz = ($name . ".zon"); 
$z = tester($TESTz);

if (($w == 0) && ($o == 0) && ($m == 0)) {
if ($z == 0) {
   die ($name, " zone set have all bad filenames!\n"); }
else  { die ($name, " contains only the .zon file in set, rest missing or bad.\n");  }
}
if (($z == 1) && ($w == 0))  {
   warn ($name, " has .zon file, but no .wld file!  Locations will be skipped.\n");
   $z = 0; }

##########################################################################
# User decides what to do based on the results...
print ("\nIf some files were invalid, you may press INTERRUPT now\n");
print ("or continue with generating a zonefile without some parts.\n");
print ("Three files will be generated as .tmp files, then merged together.\n");
print ("These are: mob.tmp, obj.tmp, and wld.tmp.  If these are in your\n");
print ("current working directory, then they will be overwritten & deleted.\n");
print ("The output zone file name if exists will also be overwritten.\n");
print ("\nEnter the name of your zone output file:\n>");
$zone = <STDIN>;
chomp($zone);

##########################################################################
# World file will be examined first, noget objects are
# contained in the world file, (not true objects in Diku)
# Files will be made even if there's nothing put in them!
print ("Loading zgen.ini...");
open(INI, "zgen.ini") or die ("zgen.ini could not be opened! Reason: ",$!,"\n");
loadini();
close(INI) or warn ("zgen.ini could not be closed down!  Reason: ",$!,"\n");
print ("done!\n");
print ("\nCreating zonefiles ",$zone,"...\n");
open(OBJ, ">obj.tmp") or die (".tmp files could not be created: ", $!, "\n");
open(WLD, ">wld.tmp") or die (".tmp files could not be created: ", $!, "\n");
open(MOB, ">mob.tmp") or die (".tmp files could not be created: ", $!, "\n");
# world file will done first.

if ($z == 1) {  print ("Locating everything...\n"); 
		locate_all($zone); }
if ($w == 1) {  print ("Creating rooms...\n"); 
		make_rooms($zone); }
if ($o == 1) {  print ("Creating objects...\n");
		make_stuff($zone); }
if ($m == 1) {  print ("Creating mobiles...\n");
		make_mobs($zone); }
 
##########################################################################
# close the three files, prepare for the merge...
close OBJ  or die ("obj.tmp could not be closed down!  Reason: ",$!,"\n");   
close WLD  or die ("wld.tmp could not be closed down!  Reason: ",$!,"\n");
close MOB  or die ("mob.tmp could not be closed down!  Reason: ",$!,"\n");

##########################################################################
# start the merge file...
##########################################################################
$x = 0;
$offset = 0;
$name = (">" . $zone . ".txt");
print ("\nCreating file ", $name, "\n");
open (ZONE, $name); 
sysopen MOB, "mob.tmp",0  or 
	die ("Newly created mob.tmp file is bad.  Reason: ",$!,"\n"); 
sysopen OBJ, "obj.tmp", 0  or
	die ("Newly created obj.tmp file is bad.  Reason: ",$!,"\n");
sysopen WLD, "wld.tmp", 0  or
	die ("Newly created wld.tmp file is bad.  Reason: ",$!,"\n"); 

### pDirt addition ###
if ($wear == 4) {
	print ZONE ("Zone = ", $zone,"\n");
	print ZONE ("Author = \"*Enter diku author's name here*\"\n");
	print ZONE ("Quest = *Enter quest name here, if any*\n");
	print ZONE ("EndZone = ", $zone, "\n\n"); }
else {
        print ZONE ("#include \"undef.h\"\n");
	print ZONE ("#include \"cflags.h\"\n");
	if ($exit == '1') { print ZONE ("#include \"exits.h\"\n"); }
	if ($zf == '1') { print ZONE ("\n%zone:",$zone,"\n"); }
	if ($rain == 0) {
		if ($rain eq "0") {
		        print ZONE ("\n%rainfall:",$rain,"\n"); } }
	else { print ZONE ("\n%rainfall:",$rain,"\n"); }
	if ($lat == 0) { 
		if ($rain eq "0") {
			print ZONE ("\n%latitude:",$lat,"\n"); } }
	else { print ZONE ("\n%latitude:",$lat,"\n"); }
	print ZONE ("\n%mobiles\n\n"); 
}

$x = 1;  # initial value so the loop starts.
while ($x) { 
    $x = sysread MOB, $data, 16384;
    if ($!) { warn ("Bad data read. Reason: ",$!,"\n"); }
    print ZONE $data; }
$x = 1;	
if ($wear != 4) {
	print ZONE ("\n\n%objects\n\n"); }
while ($x) {
    $x = sysread OBJ, $data, 16384;
    if ($!) { warn ("Bad data read. Reason: ",$!,"\n"); }
    print ZONE $data; }
$x = 1;
if ($wear != 4) {
	print ZONE ("\n\n%locations\n\n"); }
while ($x) {
    $x = sysread WLD, $data, 16384; 
    if ($!) { warn ("Bad data read. Reason: ",$!,"\n"); }
    print ZONE $data; }

#########################################################################
# do cleanup...warnings are just needed now, except for the zonefile.
#########################################################################
close WLD or warn("Can't close wld.tmp!  Reason: ",$!,"\n");
close OBJ or warn("Can't close obj.tmp!  Reason: ",$!,"\n");
close MOB or warn("Can't close mob.tmp!  Reason: ",$!,"\n");
close ZONE  or die ($name, " could not be closed down!  Reason: ",$!,"\n");
print ("\nNew zone file ", $name, " has been successfully written.\n");
print ("Please read thru this file and check for any undesirable inclusions\n");
print ("generated from the parsing.  Some flags or locations will be invalid\n");
print ("for your mud, as well as some inbalances.  Any specials in the Diku\n");
print ("zone (not likely any) will need to be duplicated by hand yourself.\n\n");
#########################################################################
# getting rid of the .tmp files...
#########################################################################
unlink ("obj.tmp") or warn ("Could not delete obj.tmp!  Reason: ",$!,"\n");
unlink ("wld.tmp") or warn ("Could not delete wld.tmp!  Reason: ",$!,"\n");
unlink ("mob.tmp") or warn ("Could not delete mob.tmp!  Reason: ",$!,"\n");

# OFFICAL END OF PROGRAM
#########################################################################
# THE SUBS --
#########################################################################
# test each file name given and load the flags...
#########################################################################
sub tester($TEST) {
  my ($TEST) = @_;
  if ((!(-r $TEST)) || (-z $TEST) || (!(-f $TEST))) {
        print ($TEST, " is not valid, ", ((-r $TEST) or "!read"), ", ",
                ((-z $TEST) or "zero"), ", ", ((-f $TEST) or "!file\n"));
	return 0;   }
  return 1;
}
#########################################################################
# The Mobile Builder Sections
#########################################################################
# Populate the zone with monsters...      
#########################################################################
sub make_mobs($zone) {
	my ($zone) = @_; my $armor; my $hps; my $damage; my @sflags; my @eflags;
	my @mflags; my @pflags; my @desc; my @exam; my $mob; my $pname;
	my $EOF = 1; my $a; my $b; my @dice; my @resulta; my @resultb; 
	my $line; my @list; my @load; my $type; my $k; my $l; my $x; my $i;

	open (ENEMY, $TESTm) or die ("Could not open ",$TESTm, " Reason: ",$!);
	$line = <ENEMY> or die ("Ugh!  Didn't get very far ");
START:    while ($EOF == 1) {
		chomp $line;
            if (!$line) { $line = <ENEMY> or return; 
                              next START; }
		if (substr($line, 0, 1) eq "\$") { return; }
		  else { $mob = ("mob" . substr($line, 1)); } # remove pound	
		print ("Writing mobile: ",$mob,"\n");
		$line = <ENEMY> or die ("Ugh!  Didn't get very far ");
		print $line;  # alias list, we don't use it.
		if (substr($line, 0, 1) eq "\$") { return; }
		$line = <ENEMY> or die ("Ugh!  Didn't get a name! ");
			  # Name this mobile.
		chomp $line; chop $line;	
		$pname = $line; undef $line;
		while ((index $line, "~") == -1) {
			$line = <ENEMY> or die ("Ugh!  Didn't get far ");
	            push @desc, $line;	
			chomp $line; }
		pop @desc;  undef $line;
		chomp $desc[@desc - 1];
            while ((index $line, "~") == -1) {
                  $line = <ENEMY> or die ("Ugh!  Didn't get far ");
                  push @exam, $line;
			chomp $line;
		}
		pop @exam; 
		($a, @list) = lister("ENEMY");  # Type, affects, wearables
		if ($a != 4) { print (join ' ',@list,"\n"); 
               die ("Improper number of values for mobile ",
                    $mob,"! Need: 4. Had:",$a,"\n"); }
            if ($spell == 1) {
              @load = (undef, undef, undef, undef, undef, undef,
			undef, undef, undef, undef, undef, undef, undef, 
			undef, undef, undef, undef, $noblind, undef, undef, 
                        undef, undef, undef, undef, undef, undef);
              if ($list[0] == 0) {
                if ($list[0] ne "0") {
                    push @eflags, flagtext($list[0], $alphabet, @load); 
                } 
              }
              @load = (undef, undef, "PickStuff", undef, 
		    undef, undef, $stay, undef,
		    $aevil, $agood, $aneu, $revenge, $helper, $nocharm,
		    undef, undef, undef, undef, undef, undef, undef,
		    undef, undef, undef, undef, undef);
            } else {
                @load = (undef, undef, "PickStuff", undef, 
		    undef, undef, $stay, undef,
		    $aevil, $agood, $aneu, $revenge, $helper, $nocharm,
		    undef, undef, undef, $noblind, undef, undef, undef,
		    undef, undef, undef, undef, undef);
            }
	if ($list[0] == 0) {
	     if ($list[0] ne "0") {
        	  push @mflags, flagtext($list[0], $alphabet, @load);
		  @resulta = mobtext1($list[0]); }
	     else { @resulta = mobnum1($list[0]); } }
	else {  @load = reverse @load; 
			push @mflags, flagnum($list[0], 33554432, @load);
		@resulta = mobnum1($list[0]); }
	if ($wear == 4) { $b = "Blind"; } else { $b = undef; } ### P A ###
	@load = ($b, undef, $align, $invis, $dmagic, $sense, $aqua, $sanct,
		undef, $curse, undef, undef, $pevil, $pgood, undef, $notrace,
		undef, undef, undef, $bird, $hide, undef, undef, undef,
		undef, undef);

	if ($list[1] == 0) {
	  if ($list[1] ne "0") {
           push @mflags, flagtext($list[1], $alphabet, @load);
	  	@resultb = mobtext2($list[1]); } 
	  else { @resultb = mobtext2($list[1]); } }
	else {  @load = reverse @load;
		push @mflags, flagnum($list[1], 33554432, @load);
		@resultb = mobnum2($list[1]); }
	$type = $list[3];  #need for skipping E stuff.
	($a, @list) = lister("ENEMY");
	if ($a != 5) { print (join ' ',@list,"\n");
die ("Improper number of values for mobile ",$mob,". Need: 5.  Had: ",$a,"\n"); 
		   }
	$armor = (($list[2] - 10) * -2);  			
	$line = lc($list[3]);
	$line =~ tr/d+/ /;
	@dice = split ' ', $line;
	if (@dice != 3) {
		die ("Hit points for ",$mob," are invalid.  Need xdy+z format.  Was:",$list[3],"\n");  }
	$hps = (($dice[0] * $dice[1]) + $dice[2]); 
	$line = lc($list[4]);
	$line =~ tr/d+/ /;
	@dice = split ' ', $line;
	if (@dice != 3) {
		die ("Damage points for ",$mob, " are invalid.  Need xdy+z format.  Was:",$list[3],"\n"); }
	$damage = (($dice[0] * $dice[1]) + $dice[2]);
	$line = <ENEMY>; # skip gold and experience 
	($a, @list) = lister("ENEMY");
	if ($a != 3) { print (join ' ',@list,"\n");
  die ("Improper number of values for ",$mob,"!  Need 3. Had:",$a,"\n"); } 
	if ($list[2] == 2) { push @sflags, "Female"; }
	push @pflags, $resulta[3];
	push @sflags, $resultb[1];
###############
	@list = grep /^$mob/, @mobiles;
	$a = @list;
	for ($i = 0; $i < $a || ($i == 0 && $a == 0); $i++) {
	   if ($wear == 4) {
		if ($i == 0)  { print MOB ("Mobile = ",$mob,"\n"); }
		   else { print MOB ("Mobile = ",$mob,"_",$i,"\n"); }
		   print MOB ("Name = \"", $pname, "\"\n");  
	   } else {
		if ($i == 0)  { print MOB ("Name = ",$mob,"\n"); }
		  else { print MOB ("Name = ",$mob,"_",$i,"\n"); }
        	  print MOB ("Pname = \"", $pname, "\"\n"); 
	   }
 	   ($k, $l) = split ' ', $list[$i];
	   if ($l) {
		print MOB ("Location = ", $l, "\n"); }
	   else {
		print MOB ("Location = limbo\@limbo\n");  }

	   @sflags = (split ' ', (join ' ', @sflags));
	   @pflags = (split ' ', (join ' ', @pflags));
	   @mflags = (split ' ', (join ' ', @mflags));
	   @eflags = (split ' ', (join ' ', @eflags));
	   if ($wear == 4) {  ### P A ###
		if (@sflags > 0) {
		   print MOB ("SFlags = ", (join ', ',@sflags), "\n"); }
		if (@pflags > 0) {
		   print MOB ("PFlags = ", (join ', ',@pflags), "\n"); }
		if (@mflags > 0) {
		   print MOB ("MFlags = ", (join ', ',@mflags), "\n"); }
	   } else {
	   	print MOB ("SFlags  {", (join ' ',@sflags),"}\n");
	   	print MOB ("PFlags  {", (join ' ',@pflags),"}\n");
	   	print MOB ("MFlags  {", (join ' ',@mflags),"}\n");
		if ($spell == 1) {
			print MOB ("EFlags  {", (join ' ',@eflags),"}\n"); } 
	   }
	   print MOB ("Strength = ",$hps,"\n");
	   print MOB ("Damage = ",$damage,"\n");
	   print MOB ("Armor = ",$armor, "\n");
	   print MOB ("Aggression = ",$resulta[1], "\n");
	   print MOB ("Speed = ",$resulta[0], "\n");
	   print MOB ("Wimpy = ",$resulta[2], "\n");
	   if ($resultb[0]) {
	       print MOB ("Visibility = ",$resultb[0],"\n");  }

	   if ($wear == 4) {  ### P A ###
	       print MOB ("Desc = \"", @desc, "\"\n"); }
	   else {
	       print MOB ("Description = \"", @desc, "\"\n");  }

	   if (@exam) { 
	       print MOB ("Examine = \"\n",@exam,"\"\n"); }

	   if ($wear == 4) {  ### P A ###
                if ($i == 0) {
                    print MOB ("EndMobile = ",$mob,"\n\n"); }
                else {
                    print MOB ("EndMobile = ",$mob,"_",$i,"\n\n"); } 
	   } else {
	        if ($i == 0) {
	            print MOB ("End = ",$mob,"\n\n"); }
	        else {
	            print MOB ("End = ",$mob,"_",$i,"\n\n"); } 
           } }
	if (uc($type) eq "E") {
		$line = <ENEMY> or $EOF = 0;
	        ($line) = split /\s+/, $line;
		while ((uc($line) ne "E") && ($EOF == 1)) {
			$line = <ENEMY> or $EOF = 0;
			($line) = split /\s+/, $line; } }
	$line = <ENEMY> or $EOF = 0;
#######################################################
#  Okay, time to clear out some variables.
	@mobiles = grep !/^$mob/, @mobiles;
	undef @sflags; undef @mflags; undef @pflags; undef @desc;
	undef @exam; undef $mob; undef $pname;
	undef @resulta; undef @resultb; undef @eflags;
        } 
return; }

#########################################################################
# Other stats for mobiles...special procedure for those only...
#########################################################################
sub mobtext1($line) {
	my ($line) = @_; my $h = 0; my $j = 0; my $k = 0; my $l = 0; my $g = 0;
	my @result; my @statsa = split //, lc($line); my $i;
	my $a = @statsa; 
	for ($i = 0; $i < $a; $i++) {
		if ($statsa[0] eq "b") { $j = 1; }
		if ($statsa[0] eq "f") { $k = 1; }
		if ($statsa[0] eq "h") { $l = 1; }
		if ($statsa[0] eq "o") { $h = 1; }
		if ($statsa[0] eq "z") { $g = 1; }
		shift @statsa;
	}
	if ($j == 1) { push @result, 0; } else { push @result, $speed; }
	if ($k == 1) { push @result, $aggr; } else { push @result, 0; } 
	if ($l == 1) { push @result, $wimp; } else { push @result, 0; }
	if ($h == 1 && $g == 1) { push @result, "NoSummon NoHassle"; } 
	elsif ($h == 1) { push @result, "NoSummon"; }
	elsif ($g == 1) { push @result, "NoHassle"; }
		else { push @result, undef; }
	return @result;
}
sub mobtext2($line) {
	my ($line) = @_;  my @statsb = split //, lc($line);  my $n = 0; 
	my @result; my $p = 0; my $a = @statsb; my $i;
	for ($i = 0; $i < $a; $i++) {
	  if ($statsb[0] eq "a") { $n = 1; }
	  if ($statsb[0] eq "b") { $p = 1; }
	  shift @statsb; }
	if ($p == 1) { push @result, $vis; } else { push @result, 0; }
	if ($n == 1 && $wear != 4) { 
		push @result, $sblind; } else { push @result, undef; }
	return @result;
}

sub mobnum1($num) {
	my ($num) = @_;  my @result;	
	my @flags; my $binary = 33554432; 
	while ($num >= 1)  {
	  	  if (($num - $binary) >= 0) {
			push @flags, 1;
			$num = $num - $binary; }
	  else { push @flags, 0; }
	$binary = $binary / 2; }
	if ($flags[24] == 1) { push @result, 0;} else { push @result, $speed;}
        if ($flags[20] == 1) { push @result, $aggr; } else { push @result, 0;}
	if ($flags[18] == 1) { push @result, $wimp; } else { push @result, 0;}
	if ($flags[11] == 1 && $flags[0] == 1)
		  { push @result, "NoSummon NoHassle";}
	elsif ($flags[11] == 1) { push @result, "NoSummon"; }
	elsif ($flags[0] == 1) { push @result, "NoHassle"; }
                else { push @result, undef; }
	return @result;
}
sub mobnum2($num)  {
        my ($num) = @_;  my @flags;
	my $binary = 33554432; my @result; 
        while ($num >= 1)  {
                  if (($num - $binary) >= 0) {
                        push @flags, 1;
                        $num = $num - $binary; }
          else { push @flags, 0; }
        $binary = $binary / 2; }
	if ($flags[22] == 1) { push @result, $vis; } else { push @result, 0; }
	if ($flags[23] == 1) { push @result, $sblind; } 
		else { push @result, undef; }
	return @result;
}

#########################################################################
# The Object Builder Sections
#########################################################################
# Lets make all the stuff in the zone...real messy...and long!
#########################################################################
sub make_stuff($zone) {
	my ($zone) = @_; my $line; my @list; my @results; my @load;
	my $obj; my $pname; my $altname; my @oflags; my @wflags;
	my $bvalue; my $size; my $weight; my @desc0; my $type; my $ovis;
	my @exam; my $EOF = 1; my $a; my @flags; my $k; my $l; my $x; my $i;
########
	open (STUFF, $TESTo) or die ("Could not open ",$TESTo," Reason: ",$!);
	$line = <STUFF> or die ("Ugh!  Didn't get very far ");
SSTART:	while ($EOF == 1) {
		chomp $line;
            if (!$line) { $line = <STUFF> or return;
                              next SSTART;  }
	      if (substr($line, 0, 1) eq "\$") { return; }
		  else { $obj = ("obj" . substr($line, 1)); } # remove pound 	
		print ("Writing object: ",$obj,"\n");
		$line = <STUFF> or die ("Ugh!  Didn't get very far ");
		if (substr($line, 0, 1) eq "\$") { return; }
		# alias list, we don't use it.
		($a, @list) = listtid("STUFF");  # Full name of object on Dikus
		if ($a > 1) { 
			($a, @list) = trimbrkword(@list)} # trim the junk out
		if ($a > 1) {
			$pname = $list[$a - 1];
			$altname = $list[$a - 2]; }
		elsif ($a == 1) {
			$pname = $list[0];  }
		else { 
die ("Short description field is required, missing for object ",$obj,"!\n");  }
################
		$line = <STUFF> or die ("Ugh!  Didn't get far ");
		chomp $line;
 		while (substr ($line, -1, 1) ne "~")  {
			push @desc0, $line;	
			$line = <STUFF> or die ("Ugh!  Didn't get far ");
			chomp $line;
			}
		push @desc0, (split "~", $line);
################
		$line = <STUFF> or die("Ugh!  Didn't go far ");
			  # Action line, we don't use it.
################
		($a, @list) = lister("STUFF");  # Type, affects, wearables
		if ($a != 3) { print (join ' ',@list,"\n"); 
die ("Improper number of values for object ",$obj,"! Need 3. Had:",$a,"\n");
		}
		$type = $list[0];  # retain type object for later use.	
        @load = ("Lit", $hum, undef, $nodon, undef, undef, $magic,
	    $nodrop, $bless, $ogood, $oevil, $oneu, $omage, $ocler, 
	    $othief, $owarr, undef, undef, undef, $boat, "Destroyed",
	    undef, undef, undef, undef, undef);
		if ($list[1] == 0) {
		   if ($list[1] ne "0") {
	              push @oflags, flagtext($list[1], $alphabet, @load);
		      $ovis = otextinvis($list[1]);
	   	} }
		else {  @load = reverse @load; 
		   push @oflags, flagnum($list[1], 33554432, @load); 
		   $ovis = onuminvis($list[1], 33554432);  # was 1048576
                }
                @load = (undef, $finger, $neck, $body, $head, $legs, $feet,
       		$hands, $arms, $shield, $back, $waist, $wrist, undef, 
			undef, undef, undef, undef, undef, undef, undef, undef,
			undef, undef, undef, undef);
		if ($wear == 1 || $wear == 4) {
                   if ($list[2] == 0) {
		     if ($list[2] ne "0") {
		     push @oflags, oitemtext(split //, $list[2]);
                     @wflags = flagtext($list[2], $alphabet, @load);
		     push @oflags, @wflags; ## combine two lists of flags
		   } }
                   else { 	
		      push @oflags, oitemnum($list[2]);
		      @load = reverse @load; 
		      @wflags = flagnum($list[2], 33554432, @load);
		      push @oflags, @wflags;
		   } }
		elsif ($wear == 2) {
		   if ($list[2] == 0) {
		      if ($list[2] ne "0") {
			push @oflags, oitemtext(split //, $list[2]);
			@wflags = flagtext($list[2], $alphabet, @load);
			} }
		   else  {
		      push @oflags, oitemnum($list[2]);
		      @load = reverse @load;
		      @wflags = flagnum($list[2], 33554432, @load); } 
	          if (grep /^$shield/, @wflags) {
		      push @oflags, $shield;
		      @wflags = grep !/^$shield/, @wflags; } } 
		elsif ($wear == 0 || $wear == 3) {
                   if ($list[2] == 0) {
		      if ($list[2] ne "0") {
			push @oflags, oitemtext(split //, $list[2]);
                        @wflags = flagtext($list[2], $alphabet, @load);
			} }
                   else { 	push @oflags, oitemnum($list[2]);
		     @load = reverse @load;
		     @wflags = flagnum($list[2], 33554432, @load); } }
		else { die("Invalid number for Wear Flags in zgen.ini, line 2, valid: (0-4),\ncurrent: ",$wear,"\n"); }
################
		if (@wflags) { push @oflags, "Wearable"; }
		($a, @list) = lister("STUFF");	
		if ($a != 4) { print (join ' ',@list,"\n");
die ("\nImproper number of values for object stats! Need 4. Had:",$a,"\n"); }
		@results = oflagtype($pname, $type, @list); 
		push @oflags, $results[0];
		($a, @list) = lister("STUFF");  # Get weight, values
		if ($a != 3) { print (join ' ',@list,"\n"); 
die ("\nImproper number of values for weight and value! Need 3. Had:",$a,"\n");
		}
		$weight = $list[0];
		$bvalue = int $list[2] / 10; # Determining their worth
################
		$line = <STUFF> or $EOF = 0; # Want to know if the end is hit
		($line) = split /\s+/, $line;
		while ((uc($line) eq "E" || uc($line) eq "A" || uc($line) eq "B") && $EOF == 1) 
		{       if (uc($line) eq "E") {
				$line = <STUFF>; # Skip item embedded stuff
				print $line;  undef $line;
				while ((index $line, "~") == -1) {
                        	    $line = <STUFF> or die("No tilde found ");
				    push @exam, $line;
				    chomp $line; } 
			        pop @exam; }
			elsif (uc($line) eq "A" || uc($line) eq "B") { 
			  $line = <STUFF> or die("No line after A/B found "); }
				 # Object affects, not used
			$line = <STUFF> or $EOF = 0;
			($line) = split /\s+/, $line;  }
################
 		# This last loop will kick out at the start of the next item
		# or when EOF has been set.  Now to build the item...
		@list = grep /^$obj/, @objects;		
		$a = @list;
	for ($i = 0; $i < $a || ($i == 0 && $a == 0); $i++) {
	   if ($wear != 4) {  ### pDirt Addition ###
		if ($i == 0) {
		        print OBJ ("Name = ",$obj,"\n"); }
		else {
			print OBJ ("Name = ",$obj, "_", $i, "\n"); }
		print OBJ ("Pname = ", $pname, "\n"); }
	   else {
		if ($i == 0) {
			print OBJ ("ObjectName = ",$obj, "\n"); }
		else {
			print OBJ ("ObjectName = ",$obj, "_", $i, "\n"); }
		print OBJ ("Name = ", $pname, "\n");  }
	   if ($altname) { print OBJ ("Altname = ",$altname, "\n"); }
	   ($k, $l) = split ' ', $list[$i];
	   if ($l) {
		print OBJ ("Location = ", $l, "\n"); }
	   else {
		print OBJ ("Location = IN_ROOM:limbo\@limbo\n");  }
	   print OBJ ("State = ", $results[3], "\n");
	   print OBJ ("Maxstate = ", $results[4], "\n");	
	   if ($ovis) { print OBJ ("Visibility = ", $vis, "\n"); }
	   if ($results[2]) { print OBJ ("Armor = ", $results[2], "\n"); }
	   if ($results[1]) { print OBJ ("Damage = ", $results[1], "\n"); }
	   if ($wear == 4) {  ### P A ###
		print OBJ ("BaseValue = ", $bvalue, "\n"); }
	   else {
           	print OBJ ("Bvalue = ",$bvalue,"\n");  }
	   if ($results[5]) { 
		print OBJ ("Size = ", $results[5], "\n"); }
	   else { 
		print OBJ ("Size = ", $weight, "\n"); } 
	   print OBJ ("Weight = ", $weight, "\n"); 
	   if ($results[6]) { print OBJ ("Key = ",$results[6],"\n"); }
	   @oflags = (split ' ', (join ' ', @oflags));
	   if ($wear == 4) {  ### P A ###
		if (@oflags > 0) {
	           print OBJ ("Oflags = ", (join ', ',@oflags), "\n"); }  }
	   else {
	        print OBJ ("Oflags { ",(join ' ',@oflags)," }\n");  }
           if (@wflags > 0) { 
	      if ($wear == 0) { 
		  print OBJ ("Wflags {",join ' ',@wflags, "}\n");
		  print OBJ ("Wlayer = 1\n"); }
              elsif ($wear == 2) {
		  print OBJ ("Aflags {",join ' ',@wflags, "}\n"); } }
	if ($wear == 4) {  ### P A ###
	  print OBJ ("Desc0 = \"", @desc0, "\"\n");
          if ($results[7]) { print OBJ ("Desc1 = \"", $results[7], "\"\n"); }
          if ($results[8]) { print OBJ ("Desc2 = \"", $results[8], "\"\n"); }
	} else {
	  print OBJ ("Desc[0] = \"", @desc0, "\"\n");
	  if ($results[7]) { print OBJ ("Desc[1] = \"", $results[7], "\"\n"); }
          if ($results[8]) { print OBJ ("Desc[2] = \"", $results[8], "\"\n");}}	
	if (@exam) { print OBJ ("Examine = \"\n", @exam, "\"\n"); }
	if ($wear == 4) {  ### P A ###
		if ($i == 0) {
		   print OBJ ("EndObject = ",$obj,"\n\n"); }
		else {
		   print OBJ ("EndObject = ",$obj,"_",$i,"\n\n"); } }
	else {
		if ($i == 0) {
                   print OBJ ("End = ",$obj,"\n\n"); }
                else {
                   print OBJ ("End = ",$obj,"_",$i,"\n\n"); } }
	}
################
# Clear some of the variables...
		@objects = grep !/^$obj/, @objects;
		undef $obj; undef $pname; undef $altname; undef @results;
		undef @wflags; undef @oflags; undef @desc0; undef @exam;
	} # The next item will start, or we exit out of objects now.
return;
    }
#########################################################################
sub oflagtype($pname, $type, @stats) {
	my ($pname, $type, @stats) = @_; my $desc1; my $desc2;
	my $flags; my $damage; my $armor; my $state = 0; my @con;
	my $maxstate = 0; my $key; my $size;
	if ($type == 1) {
	   if ($stats[2] == -1)  { $flags = "Lightable"; }
	   elsif ($stats[2] == 0) { $flags = "Destroyed"; }
	   else { $flags = "Lightable Extinguish";  } }
	elsif ($type == 2) { $flags = $scroll; }
	elsif ($type == 3) { $flags = $wand;   }
	elsif ($type == 4) { $flags = $staff;  }
	elsif ($type == 5) { $flags = "Weapon";
			     $damage = $stats[1] * $stats[2]; }
	elsif ($type == 9) { $flags = "Armor";
			     $armor = $stats[0]; }
	elsif ($type == 10) { $flags = $potion; }
	elsif ($type == 15) {
		my $binary = 8; my $num = $stats[1]; my @con;
		$size = $stats[0];
	        while ($num >= 1)  {
			if (($num - $binary) >= 0) {
	        	        push @con, 1;
	                	$num = $num - $binary; }
		        else { push @con, 0; }
		        $binary = $binary / 2; }
		$flags = "Container";
		if ($con[0] == 1) {
			 $state = 0;
                         $maxstate = 2;
                         $desc1 = ("The " . $pname . " is open.\n");
                         $desc2 = ("The " . $pname . " is locked.\n");
			 $flags=($flags." Openable Lockable"); }
		if ($con[2] == 1) { $state = 1; $maxstate = 2; }
		if ($con[3] == 1) { $state = 2; $maxstate = 2; }
		if ($stats[2] > 0)  { $key = "obj".$stats[2]; } }
	elsif (($type == 17) || ($type == 23)) {
		$flags = "Food";
		if ((($stats[2] >= 1) && ($stats[2] <= 6)) || ($stats[2] == 7) || ($stats[2] == 8)) {
			$flags = ($flags . " " . $booze); }
		if (($stats[2] == 9) || ($stats[2] == 13)) { undef $flags; } 
		if ($stats[3] > 0) { $flags = ($flags . " " . $poison); } } 
	elsif ($type == 18) { $flags = "Key"; }
	elsif ($type == 19) { $flags = "Food";
		if ($stats[3] > 0) { $flags = ($flags . " " . $poison); } }
	elsif ($type == 22) { $flags = $boat; }
	elsif ($type == 26) { $flags = "Food"; }
	elsif ($type == 27) { $flags = $scuba; }
	elsif ($type == 28) { $flags = $wings; }
	elsif ($type == 29) { $flags = "Container"; }
	elsif ($type == 33) { $flags = "NoGet"; }
	return ($flags, $damage, $armor, $state, $maxstate, $size,
		 $key, $desc1, $desc2);
    }

#########################################################################
# This inserts the NoGet flag only, kept seperate from the rest...
sub oitemtext($flags) {
	my ($flags) = @_; my $j; my $k = 0; my @tflags; 
	@tflags = split //, lc($flags);
	my @xflags; 
	foreach $j (@tflags) {
		if ($j eq "a") {
			 $k = 1; } }
	if ($k == 0) { push @xflags, "NoGet"; }
	return @xflags; 
    }
#########################################################################
# Same thing......
sub oitemnum($num) {
	my ($num) = @_; my @xflags;
	if (($num % 2) == 0) { push @xflags, "NoGet"; }
return @xflags; 
    }
#########################################################################
# This determines if an object's invisible, kept seperate from the rest...
sub otextinvis($flags) {
        my ($flags) = @_; my $j; my $k = 0; my @tflags;
        @tflags = split //, lc($flags);
        foreach $j (@tflags) {
                if ($j eq "f" || $j eq "u") {
                         $k = 1; } }
        return $k;
    }
#########################################################################
# Same thing......
sub onuminvis($num, $binary) {
    my ($num, $binary) = @_; my @flags; my $k = 0;
    while ($num >= 1)  {
      if (($num - $binary) >= 0) {
          push @flags, 1;
          $num = $num - $binary; }
      else { push @flags, 2; }
      $binary = $binary / 2;
      if ($binary == 0) {
          die("Missummed bitvector discovered!  Amount left: ",$num); } }
    if ($flags[15] == 1 || $flags[0] == 1)  {
	$k = 1; }
    return $k;
}

#########################################################################
# End of the object builders....
#
#########################################################################
# The Room Builder Sections  (Also "flannel" and doors)
#########################################################################
sub make_rooms($zone) {
	my ($zone) = @_; my $line; my @list; my @load; my $dir; my $d;
        my $room; my @exits = undef; my $rmtitle; my @desc; my @zflags;
	my ($north, $south, $west, $east, $up, $down); my $x; my $att;
	open (WORLD, $TESTw);
	while ($line = <WORLD>) {
		chomp $line;
		if (substr($line, 0, 1) eq "\$") { return; }
		  else { $room = ($zone . substr($line, 1)); }  # remove pound
		print ("Writing room:  ",$room," ");
		$line = <WORLD> or die ("Ugh!  Didn't get far "); 
		chomp $line;
		chop $line;  # remove newline & tilde
		$rmtitle = $line;
		print ($rmtitle, "\n");
		if (substr($rmtitle, 0, 1) eq "\$") { return; }
			else {        ### pDirt addition ###
			   if ($wear != 4) 
			       { $rmtitle = ($rmtitle . "^\n"); } }
		$line = <WORLD> or die ("Ugh!  Didn't get far ");
		chomp($line); 
		while ((index $line, "~") == -1) {
			push @desc, $line . "\n";
			$line = <WORLD> or die ("Ugh!  Didn't get far ");
			chomp($line); }
		if ($wear != 4) {  ### pDirt addition ###
		     push @desc, "^\n"; }  # replace tilde with caret
	 	($a, @list) = lister("WORLD");	
		if ($a != 3) { print (join ' ',@list,"\n");
die ("Improper number of values for room stats. Need 3. Had:",$a,"\n"); }
	# Test for text bits or numeric bits
      @load = ("Dark", "Death", "NoMobiles", $indoor, "Peaceful", "SoundProof",
           $notrack, "NoMagic", "OnePerson", "Private", $power,
		undef, undef, "CantSummon", undef, undef, undef, undef, undef,
		undef, undef, undef, undef, undef, undef, undef);

	if ($list[1] == 0) {
	   if ($list[1] ne "0") {
  	      @zflags = flagtext($list[1], $alphabet, @load); } }
	else {
		@load = reverse @load;
   	@zflags = flagnum($list[1], 33554432, @load); }
	@zflags = (@zflags, lflagsect($list[2]));
	if (@atti > 0) {
	 	$att = lflagatt($list[2]); }
	$line = <WORLD> or die ("Ugh!  Didn't get far ");
	chomp $line;	
	# Insert the exits...
	($dir) = split /\s+/, $line;
	while (uc($dir) ne "S") {
	  if (uc($dir) eq "E") {
		roomdesc($room); }
	    elsif ($dir eq "D0") { $d = addexit($dir, $room);
				   if (defined $d) { $north = (" n:" . $d); } }
	    elsif ($dir eq "D1") { $d = addexit($dir, $room);
				   if (defined $d) { $east = (" e:" . $d); } }
	    elsif ($dir eq "D2") { $d = addexit($dir, $room);
				   if (defined $d) { $south = (" s:" . $d); } }
	    elsif ($dir eq "D3") { $d = addexit($dir, $room); 
				   if (defined $d) { $west = (" w:" . $d); } }
	    elsif ($dir eq "D4") { $d = addexit($dir, $room);
				   if (defined $d) { $up = (" u:" . $d); } }
	    elsif ($dir eq "D5") { $d = addexit($dir,$room);
				   if (defined $d) { $down = (" d:" . $d); } }
	    else { print ($line,"\n");
die ("Improper formatting in ",$TESTw, " in room ",$room,"!  Aborting.\nWatch those extra spaces!\n"); }
	  $line = <WORLD> or die ("Ugh!  Didn't get far ");
	  chomp $line;
          ($dir) = split /\s+/, $line;
	}   
#### pDirt additions ####
@zflags = (split ' ', (join ' ', @zflags));
if ($wear == 4) {
	print WLD ("Location = ",$room,"\n");
	print WLD ("Title = \"", $rmtitle, "\"\n");
	print WLD ("Desc = \"");
	print WLD @desc; print WLD ("\"\n");
	if (@zflags != 0)  {
	    print WLD ("Lflags = ", (join ', ', @zflags),"\n");  }
	if (defined $north) { @exits = split /:/, $north;
			print WLD ("North = ", $exits[1], "\n"); }
	if (defined $west)  { @exits = split /:/, $west;
			print WLD ("West = ", $exits[1], "\n"); }
	if (defined $south) { @exits = split /:/, $south;
			print WLD ("South = ", $exits[1], "\n"); }
	if (defined $east)  { @exits = split /:/, $east;
			print WLD ("East = ", $exits[1], "\n"); }
	if (defined $up)    { @exits = split /:/, $up;
			print WLD ("Up = ", $exits[1], "\n"); }
	if (defined $down)  { @exits = split /:/, $down;
			print WLD ("Down = ", $exits[1], "\n"); }
	print WLD ("EndLocation = ", $room, "\n\n");
} else {
	@exits = ($north, $south, $west, $east, $up, $down);	
	print WLD ($room, @exits,";\n");
	if (defined $att) { print WLD ("Attitude = ",$att,"\n"); }
        print WLD ("lflags { ",(join ' ',@zflags)," }\n");
	print WLD $rmtitle;
	print WLD @desc; print WLD "\n";  }
#########################################################################
# This room is done, time to clear some variables for the next.
	undef @desc; undef $rmtitle; undef @zflags; undef $room;
	undef $north; undef $south; undef $east; undef $west;
	undef $up; undef $down; undef $att;
 }
return; }			
#########################################################################
# Add display objects for a room that you can't take.
#########################################################################
sub roomdesc($room) {
	my $oname; my $pname; my $altname;
	my @odesc; my $a; my $line; my @list;
	my ($room) = @_;
	($a, @list) = listtid("WORLD");
	if ($a == 3) {
		$altname = $list[2];
		$pname = $list[1];
		$oname = ($list[0] . "_" . $room); }
	elsif ($a == 2) {
		$altname = $list[2];
		$pname = $list[0];
		$oname = ($list[0] . "_" . $room); }
	elsif ($a == 1) {
		$oname = ($list[0] . "_" . $room);
		$pname = $list[0]; }
	elsif ($a == 0) {
	  die ("'E' line inserted in ", $TESTw, " missing a description for room ",$room, "!\n");
		}
	else { $altname = $list[$a - 1];
	       $pname = $list[$a - 2];
	       $name = $list[$a - 3]; }
        $line = <WORLD> or die ("Ugh!  Didn't get far ");
        chomp $line;
        while ((index $line, "~") == -1)
        { 
		push @odesc, $line . "\n";
                $line = <WORLD> or die ("Ugh!  Didn't get far ");
                chomp $line;
        }
        if ($wear == 4) {   ### pDirt additions ###
	   print OBJ ("Object = ",$oname, "\n");
	   if ($pname) { print OBJ ("Name = ", $pname, "\n"); } }
        else {
	   print OBJ ("Name = ", $oname, "\n");
	   if ($pname) { print OBJ ("Pname = ",$pname,"\n"); } }
	if ($altname) { print OBJ ("Altname = ",$altname, "\n"); }	
	print OBJ ("Location = IN_ROOM:",$room,"\n");
	if ($wear == 4) {
		print OBJ ("Oflags = Noget\n"); }
	else {
	        print OBJ ("Oflags { Noget }\n"); }
	print OBJ ("Examine = \"\n");
	print OBJ @odesc;
	print OBJ ("\" \n");
	if ($wear == 4) {
		print OBJ ("EndObject = ",$oname,"\n\n"); }
	else {
		print OBJ ("End = ",$oname, "\n\n"); }
	return; }

#########################################################################
# Add the room exits, including doors...
#########################################################################
sub addexit($dir, $room) {
	my ($dir, $room) = @_;  my $linked; my $line; my @list; my @exit;
	my @desc; my $oname; my $pname; my $altname; my $key; my $a; my $b; 
	my $state = 0; my $t = undef; my @u = undef; my $x; my @oflags;
	my @junk;
	$line = <WORLD> or die ("Ugh!  Didn't get far ");
	chomp $line;
	while ((index ($line, "~")) == -1) {       
            push @desc, $line . "\n";
		$line = <WORLD> or die ("Ugh!  Didn't get far ");
		chomp $line;
	}
	if ((index ($line, "~")) > 0) {
		@junk = split(/~/, $line);
		push @desc, $junk[0] . "\n";
	} 
	$b = @desc;
	($a, @list) = listtid("WORLD");
	if ($a == 3) {
	        $altname = $list[2];
	        $pname = $list[1];
		$oname = $list[0]; }
	elsif ($a == 2) {
		$altname = $list[1];
		$pname = $list[0];
		$oname = $list[0]; }
	elsif ($a == 1) {
		$pname = $list[0];
		$oname = $list[0]; }
	elsif ($a == 0 && $b > 0) {
          if ($dirs != 1) { 
		   if ($dir eq "D0")    { $oname = ("north_" . $room);
					  $pname = "north"; }
		   elsif ($dir eq "D1") { $oname = ("east_" . $room); 
					  $pname = "east";  } 
		   elsif ($dir eq "D2") { $oname = ("south_" . $room);
					  $pname = "south"; }
		   elsif ($dir eq "D3") { $oname = ("west_" . $room); 
					  $pname = "west";  }
		   elsif ($dir eq "D4") { $oname = ("up_" . $room);   
					  $pname = "up";    }
		   else { $oname = ("down_" . $room);
			  $pname = "down"; }
	}    }
	else {  $altname = $list[$a - 1];
		$pname = $list[$a - 2];
                $name = $list[$a - 3]; }
	($a, @list) = lister("WORLD");
	if ($a != 3) {	print ("\n",$line,"\n",@list,"\n"); 
		die ("Improper number of values for exits in ",$TESTw," in room ",$room,"!\nNeed 3.  Had: ",$a,"\n"); }
	if ($list[0] > 0) {
                foreach $t(@exit = grep /^$room/,@doors) {
                      @u = split /\s+/, $t;
		      if ($u[2] > 2) { 
			 if ($u[2] == 8)  { push @oflags, "Destroyed"; }
			 $u[2] = 2; } 
                      if ($dir eq "D0" &&  $u[1] == 0)    { $state = $u[2];}
                         elsif ($dir eq "D1" && $u[1] == 1) { $state = $u[2];}
                         elsif ($dir eq "D2" && $u[1] == 2) { $state = $u[2];}
                         elsif ($dir eq "D3" && $u[1] == 3) { $state = $u[2];}
                         elsif ($dir eq "D4" && $u[1] == 4) { $state = $u[2];}
                         elsif ($u[1] == 5)  { $state = $u[2];}
                         }
		if (length($oname) == 0) {
		   die ("Door defined for ", $dir, " in ", $TESTw, " in room ", $room, 
			"\nbut did not have a defined name!\n");
		}
		$linked = ($oname . "_" . $room);
		$oname = ($oname . "_" . $zone . $list[2]);	
		$dir = ("^" . $oname);	
		if ($list[1] > -1) { $key = ("obj" . $list[1]); } }
	else {  if ($list[2] > -1) { $dir = ($zone . $list[2]); }
			else { undef $dir; } }
	if ($oname) { 
	   if ($wear == 4)  {  ### pDirt additions ###
		print OBJ ("Object = ", $oname,"\n");
		print OBJ ("Name = ", $pname, "\n");  }
	   else {	
		print OBJ ("Name = ",$oname,"\n");
		print OBJ ("Pname = ",$pname,"\n");  }
	   if ($altname) { print OBJ ("Altname = ",$altname, "\n"); }
	   if ($list[0]) { print OBJ ("Linked = ",$linked,"\n");
		print OBJ ("State = ",$state,"\n");
		print OBJ ("Maxstate = 2\n");
		if ($key) { print OBJ ("Key = ",$key, "\n"); }
		push @oflags, "Openable NoGet Lockable";
	  	if ($wear == 4) {  ### pDirt additions ###
		   print OBJ ("Desc2 = \"The ", $pname, " is locked.\"\n");
		   print OBJ ("Desc1 = \"The ", $pname, " is closed.\"\n");
		   print OBJ ("Desc0 = \"The ", $pname, " is open.\"\n"); }
		else {
		   print OBJ ("Desc[2] = \"The ",$pname," is locked.\"\n"); 
		   print OBJ ("Desc[1] = \"The ",$pname," is closed.\"\n");
		   print OBJ ("Desc[0] = \"The ",$pname," is open.\"\n"); } }
		else {
		   push @oflags, "NoGet"; }
	   @oflags = (split ' ', (join ' ', @oflags));
	   if ($wear == 4) {  ### P A ###
		print OBJ ("Oflags = ",(join ', ', @oflags),"\n"); }
	   else {
		print OBJ ("Oflags { ",join ' ',@oflags," }\n");   }
 	   print OBJ ("Location = IN_ROOM:",$room,"\n");
	   if ($b > 0) { print OBJ ("Examine = \"\n",@desc,"\"\n"); }
	   if ($wear == 4) {  ### P A ###
		print OBJ ("EndObject = ", $oname, "\n\n"); }
	   else {
		print OBJ ("End = ", $oname, "\n\n"); } }
	return $dir;
    }

#########################################################################
# Sector type bit conversion to some lflags
######################################################################### 
sub lflagsect($sect) {
	my ($sect) = @_; 
	if ($sect == 0) { return $indoor; }
	  elsif ($sect == 1)  { return $city; }
	  elsif ($sect == 2)  { return $field; }
	  elsif ($sect == 3)  { return $forest; }
	  elsif ($sect == 4)  { return $hills; }
	  elsif ($sect == 5)  { return $mount; }
	  elsif ($sect == 6 || $sect == 7)  { return $water; }
	  elsif ($sect == 8 || $sect == 11)  { return $under; }
	  elsif ($sect == 9)  { return $fly; }
	  elsif ($sect == 10)  { return $desert; }
	  elsif ($sect == 12)  { return $maxi; }
	else { warn ("Illegal sector type used: ",$sect,"\n"); }
 	return ;
    }
#################################
### Attitude for sector types ###
#################################
sub lflagatt($sect) {
	my ($sect) = @_;
	if ($sect == 1) { return $atti[0]; }
	  elsif ($sect == 2) { return $atti[1]; }
	  elsif ($sect == 3) { return $atti[2]; }
	  elsif ($sect == 4) { return $atti[3]; }
	  elsif ($sect == 5) { return $atti[4]; }
	  elsif ($sect == 6 || $sect == 7) { return $atti[5]; }
	  elsif ($sect == 8) { return $atti[6]; }
	  elsif ($sect == 9) { return $atti[7]; }
	  elsif ($sect == 10) { return $atti[8]; }
	return;  
}
#########################################################################
# Universal flag builder...called with different sets of flags to form.
#########################################################################
sub flagnum($num, $binary, @load) {
 my ($num, $binary, @load) = @_;  my @xflags; my @flags; my $i;
 while ($num >= 1)  {
 if (($num - $binary) >= 0) {
   push @flags, 1;
   $num = $num - $binary; }
   else { push @flags, 2; }
   $binary = $binary / 2; 
	if ($binary == 0) { 
		die("Missummed bitvector discovered!  Amount left: ",$num); } }
 for ($i = 0; $i < @load; $i++) {
 if ($flags[$i] == 1) {
	if (defined $load[$i]) {	
	    push @xflags, $load[$i]; } } }
 return @xflags;
}

sub flagtext($flags, $text, @load) {
        my ($flags, $text, @load) = @_;  my @xflags; my $i;
        my @tflags = split //, lc($flags);
        my @rflags = split //, lc($text);
        for ($i = 0; $i < @load; $i++)  {
            if ($tflags[0] eq $rflags[$i]) {
		if (defined $load[$i]) {
                   push @xflags, $load[$i]; } 
                shift @tflags;
	} }
	if (@tflags > 0) { 
	   die("Misordered bitvector discovered!  Amount left: ",@tflags);  }
        return @xflags;
}
#########################################################################
# The Locator Sections--build lists for later use.
#########################################################################
# Lots of messy case switching with if-elsif-else again!
#########################################################################
sub locate_all($zone) {

my $line; my @list; my $last; my $a; my $curr; my $k;
open (LOCATE, $TESTz) or die ("Could not open ",$TESTz," Reason: ",$!);
$line = <LOCATE>; # Skip Virtual Number
$line = <LOCATE>; # Skip zone name
$line = <LOCATE>; # Skip zone modes
while ($list[0] ne "S") {
    ($a, @list) = lister("LOCATE");	
    if ($a == 0) { 
	warn("Blank lines found in ",$TESTz,".  Assuming EOF.");
	return;  }
    elsif (($list[0] eq "*") || (substr($list[0], 0, 1) eq "*"))
		 {} # do nothing! Filter comments out.
    elsif ($a >= 1 && $a <= 3) {
	if ($list[0] ne "S") { print (join ' ', @list,"\n");
die ("Improper number of values for zone command. Need: 4 or 5. Had: ",$a,"\n");
} }
    elsif ($a >= 4) {

       if (uc($list[0]) eq "M") {
	  push @mobiles, ("mob" . $list[2] . " " . $zone . $list[4]); 
	  $last = ("mob" . $list[2]);  
	  if ($curr ne $last) { 
		$curr = $last; $k = 0;} 
	  else { $k = $k + 1; }
	}
       elsif (uc($list[0]) eq "O") {
	  push @objects, ("obj" . $list[2] . " IN_ROOM:" . $zone . $list[4]); }
       elsif (uc($list[0]) eq "G") {
	if ($k == 0) {
	  push @objects, ("obj" . $list[2] . " CARRIED_BY:" . $last); }
	else {
	push @objects, ("obj" . $list[2] . " CARRIED_BY:" . $last . "_" . $k); }
       } 
     elsif (uc($list[0]) eq "E") {

	  if (($list[4] <= 0) || ($list[4] >= 17)) {
	   if ($k == 0) {
	     push @objects, ("obj" . $list[2] . " CARRIED_BY:" . $last); }
	   else {
	     push @objects, ("obj" . $list[2] . " CARRIED_BY:" . $last . "_" . $k); } 
}          elsif ($list[4] == 16) {
	    if ($k == 0) {
	      push @objects, ("obj" . $list[2] . " WIELDED_BY:" . $last); }
	    else {
	      push @objects, ("obj" . $list[2] . " WIELDED_BY:" . $last . "_" . $k); } 
}	  else {
	    if ($k == 0) { 
	      push @objects, ("obj" . $list[2] . " WORN_BY:" . $last); }
	    else {
	      push @objects, ("obj" . $list[2] . " WORN_BY:" . $last . "_" . $k); }
      }}
       elsif (uc($list[0]) eq "P") {
	if ($k == 0) {
	  push @objects, ("obj" . $list[2] . " IN_CONTAINER:obj" . $list[4]); }
	  else {
        push @objects, ("obj" . $list[2] . " IN_CONTAINER:obj" . $list[4] . "_" . $k); } }
       elsif (uc($list[0]) eq "D") {
	  push @doors, ($zone . $list[2] . " " . $list[3] . " " . $list[4]);}
       elsif (uc($list[0]) eq "R") {} # do nothing!
else {warn ($list[0], " is not a valid zone command!  Skipping to next.\n");}
   }
}
return;
}
#########################################################################
# The list maker--this repeats enough to make a sub out of it.
#########################################################################
sub lister($x) {
        my ($x) = @_; my $line; my @list; my $a;
        no strict 'refs';  # Gotta shut it off, so we can ref a file in $x
        $line = <$x> or die(" Ugh!  Didn't get far ");
        use strict 'refs';
        chomp $line;
        @list = split /\s+/, $line;
        $a = @list;
return ($a, @list); }

sub listtid($x) {
        my ($x) = @_; my $line; my @list; my $a;
        no strict 'refs';
        $line = <$x> or die (" Ugh!  Didn't get far ");
        use strict 'refs';
        chomp $line;
        chop $line;
        @list = split /\s+/, $line;
        $a = @list;
return ($a, @list); }

sub trimbrkword(@list) {
	my @list = @_; my @trimlist = (); my $w; my $x; my $y; my $z;
	my @brkword = ("a", "an", "the", "large", "medium", "small", "of", 
		"high", "low", "tiny", "fine", "is", "are", "was");

	for ($w = 0; $w < @list; $w++) {
	  $y = 0;
	  for ($x = 0; $x < @brkword; $x++) {
	     if ($list[$w] eq $brkword[$x])  { $y = 1; }
        }
	  if ($y == 0) { push (@trimlist, $list[$w]); }
      } 
      $y = @trimlist;
return ($y, @trimlist);	
}

#########################################################################
# The quick and dirty way of loading it all.........ini values
#########################################################################
sub loadini {

  my @flags; my $att; my $i;
  for ($i = 1; $i <= 79; $i++) {
	push @flags, <INI> or die ("Ran out of lines at ",$i); }

  chomp @flags;
  ($spell, $wear, $speed, $aggr, $vis, $wimp, $exit, $zf, $lat,
   $rain, $att, $dirs, $notrack, $power, $indoor, 
   $city, $field, $forest, $hills, $mount, $water, $under, $fly, 
   $desert, $maxi, $stay, $aevil, $agood, $aneu, $revenge,
   $helper, $nocharm, $noblind, $align, $invis, $dmagic, $sense,
   $aqua, $sanct, $curse, $pevil, $pgood, $notrace, $hide, $bird,
   $scroll, $wand, $staff, $potion, $boat, $hum, $nodon, $magic,
   $nodrop, $bless, $ogood, $oevil, $oneu, $omage, $ocler, $othief,
   $owarr, $booze, $poison, $scuba, $wings, $finger, $neck, $body, 
   $head, $legs, $feet, $hands, $arms, $shield, $back, $waist,
   $wrist, $sblind) = @flags;
   if (defined $att) {
     @atti = split ' ',$att;
     for ($i = 0; $i < @atti; $i++) {
	if ($atti[$i] == "X") {
		undef $atti[$i]; } } }
   return ;
} 
